import click
from pprint import pprint
from . import recurlests

@click.command(short_help="Runs curl's wrapper recurl")
@click.option('--headers/--no-headers', help="Shows response headers", default=False, show_default=True)
@click.option('--output/--no-output', help="Shows the output", default=False, show_default=True)
@click.option('--curl', help="Path to curl binary", default='curl', show_default=True)
@click.option('--follow/--no-follow', help="Follows redirects", default=False, show_default=True)
@click.option('--ip', help="IP to resolve to")
@click.argument("url")
def runRecurl(headers, output, curl, follow, ip, url):
  mimikra = recurlests.Recurlests(curl)
  response = mimikra.get(url, ip=ip, allow_redirects=follow)
  print('Effective HTTP version:', response.effective_http_version)
  print('Response status code:', response.status_code)
  print('Response status:', response.ok and "ok" or "error")
  print('Response content type:', response.content_type)
  print('Response elapsed:', response.elapsed)
  print('Response effective url:', response.url_effective)
  if headers:
    print('Reponse headers:')
    pprint(dict(response.headers))
  if output:
    print('Output:')
    print(response.text)
